﻿var zol_bod_google_translator = {
  prefs: null,
  targetlang: "",
  
  observe: function(subject, topic, data) { //a beallitasok valtozasanak figyelese
     if (topic != "nsPref:changed") {
        return;
     }
     switch(data) {
        case "showstatbaricon": //ha az allapotsorikon megjelenitese valtozott
           document.getElementById("statusbar-translator").hidden = !(this.prefs.getBoolPref("showstatbaricon"));
           break;
        case "hotkey_modifiers": //ha valtozott a billentyukombo (segedgombja)
           var segedgombok=this.prefs.getCharPref("hotkey_modifiers");
           document.getElementById("action-key-translator").setAttribute("modifiers",segedgombok);
           break;
        case "hotkey_keycode": //ha valtozott a billentyukombo (fogombja)
           var fogomb=this.prefs.getCharPref("hotkey_keycode");
           document.getElementById("action-key-translator").setAttribute("keycode",fogomb);
           break;
     }
  },

  onLoad: function() { //inicializalas, illetve a beallitasok es nyelvi stringek lekerese, figyelesek hozzaadasa
     this.initialized = true;
     this.prefs = Components.classes["@mozilla.org/preferences-service;1"]
                  .getService(Components.interfaces.nsIPrefService)
                  .getBranch("extensions.googletranslatorforff."); //ehhez a kiegeszitohoz tartozo beallitasok lekerdezese
     this.prefs.QueryInterface(Components.interfaces.nsIPrefBranch2);
     this.prefs.addObserver("", this, false);

     //ALAPERTEKEK
     if (!this.prefs.prefHasUserValue("targetlang")) { //celnyelv beallitasa a felhasznalo alapjan
        this.prefs.setCharPref("targetlang","en");
     }
     else { //a 2.0-s verziora frissiteshez kell, hogy igy is megjelenjen a 'mi valtozott?' oldal
        this.updateTo20=false;
     }
     if (!this.prefs.prefHasUserValue("actionforstatbaricon")) { //akcio az ikonra kattintaskor
        this.prefs.setIntPref("actionforstatbaricon",3);
     }
     if (!this.prefs.prefHasUserValue("hotkey_modifiers")) {
        this.prefs.setCharPref("hotkey_modifiers","accel");
     }
     if (!this.prefs.prefHasUserValue("hotkey_keycode")) {
        this.prefs.setCharPref("hotkey_keycode","VK_F2");
     }

     //BILLENTYUKOMBO alapbeallitasa
     var segedgombok=this.prefs.getCharPref("hotkey_modifiers");
     document.getElementById("action-key-translator").setAttribute("modifiers",segedgombok);
     var fogomb=this.prefs.getCharPref("hotkey_keycode");
     document.getElementById("action-key-translator").setAttribute("keycode",fogomb);

     this.strings = document.getElementById("translator-strings");
     document.getElementById("contentAreaContextMenu").addEventListener("popupshowing", this.showContextMenu, false); //jobbklikk-menu felugrasanak figyelese

     this.versionCheck("2.1"); //CSAK NAGYOBB FRISSITESKOR VALTOZTASD!!!!

     document.getElementById("statusbar-translator").hidden = !(this.prefs.getBoolPref("showstatbaricon"));
  },
  
  ervenyesNyelvKod: function(mi) { //ervenyes nyelvkod-e a megadott - a zh-CN es zh-TW EGYBEN VAN!!!
     var ervenyesek=["af","sq","ar","hy","az","eu","be","bn","bg","ca","zh","hr","cs","da","nl","en","et","tl","fi","fr","gl","ka","de","el","gu","ht","iw","hi","hu","is","id","ga","it","ja","kn","ko","la","lv","lt","mk","ms","mt","no","fa","pl","pt","ro","ru","sr","sk","sl","es","sw","sv","ta","te","th","tr","uk","ur","vi","cy","yi"];
     return (ervenyesek.indexOf(mi)!=-1);
  },

  versionCheck: function(ver) { //verzio ellenorzese, nagyobb frissiteskor a 'mi valtozott?' oldal megjelenitese
     var version = "-1"; //alapertek
     var firstrun = true; //alapertek
     var thismajorversion = ver; //ez valtozik minden nagyobb frissiteskor
     try {
        version = this.prefs.getCharPref("version"); //a telepitett verzio lekerese
        firstrun = this.prefs.getBoolPref("firstrun"); //lekeres, hogy elso futas-e
     }
     catch(e) {
        //semmi - nincs hibakezeles
     }
     finally {
        if (firstrun) { //ha ez az elso futas
           // Ide az elso futaskor (telepiteskor es a 2.0-s verzio elso felrakasakor) futtatando dolgok
           this.prefs.setBoolPref("firstrun",false); //soha tobbe ne legyen elso futas
           this.prefs.setCharPref("version",thismajorversion); //a telepitett verzio beallitasa
           //a forditas nyelvenek beallitasa a felhasznalo nyelve alapjan
           var userbrowserlang=navigator.language;
           if (this.ervenyesNyelvKod(userbrowserlang.substr(0,2))) {
              if (userbrowserlang.substr(0,2)!="zh") {
                 this.prefs.setCharPref("targetlang",userbrowserlang.substr(0,2));
              }
              else {
                 this.prefs.setCharPref("targetlang","zh-CN");
              }
           }
           else {
              this.prefs.setCharPref("targetlang","en"); //ha a google nem tamogatja az adott nyelvet, akkor angolra allitjuk
           }
        }
        if (version!=thismajorversion && (!firstrun || this.updateTo20)) { //ha nagyobb frissites volt, es nem elso futas
           // Ide a nagyobb verziofrissiteskor futtatando dolgok
           this.prefs.setCharPref("version",thismajorversion); //verzio frissitese
           //window.setTimeout(function(){
              gBrowser.selectedTab = gBrowser.addTab("http://translatorforfirefox.blogspot.com/p/whats-new.html");
           //}, 1500); //Firefox 2 fix - or else tab will get closed
        }
     }
  },
  showContextMenu: function(event) { //a jobbklikk-menuben a szovegforditas mutatasa, ha van kijelolt szoveg, oldalforditas, ha nincs
     document.getElementById("context-translator").hidden = !(gContextMenu.isTextSelected);
     document.getElementById("context-page-translator").hidden = (gContextMenu.isTextSelected);
  },
  
  showStatbarContextMenu: function(event) { //az ikon jobbklikk-menujeben a szovegforditas tiltasa, ha nincs ervenyes kijelolt szoveg
     if (document.getElementById("translateselected-statusbar-translator")) {
        document.getElementById("translateselected-statusbar-translator").disabled = !(this.isValidTextLength(this.getSelectedText()));
     }
  },

  getSelectedText: function(e) { //a kijelolt szoveg visszaadasa
     var focusedWindow = document.commandDispatcher.focusedWindow; //ez oldotta meg a "frame-ben nem forditok" problemat
     var selectedText = focusedWindow.getSelection().toString();
     return selectedText;
  },

  isValidTextLength: function(selectedtext) { //az atadott szoveg ellenorzese, hogy megfelel-e a hataroknak
     if (selectedtext.length>0 && selectedtext.length<=38000) {
        return true;
     }
     else {
        return false;
     }
  },

  StatusBarTranslatorClick: function(e) { //az allapotsor-ikonra kattintott
     var whataction = this.prefs.getIntPref("actionforstatbaricon");
     switch(whataction) {
        case 1: //csak a kijelolt szoveg forditasa (ha van)
           this.selectionTranslation();
           break;
        case 2: //csak oldalforditas
           this.pageTranslation();
           break;
        default: //ha van kijelolt, azt forditsa, ha nincs, akkor az oldalt (=3-as opcio, a "default" a hibakezeles miatt van)
           var selectedText = this.getSelectedText();
           if (this.isValidTextLength(selectedText)) {
              this.selectionTranslation();
           }
           else {
              this.pageTranslation();
           }
     }
  },

  selectionTranslation: function(e) { //kijeloles forditasa
     var selectedText = this.getSelectedText();
     this.refreshInformation(selectedText);
  },

  pageTranslation: function(e) { //oldalforditas
     var cel = this.prefs.getCharPref("targetlang");
     var docurl = content.location.href;
     var fordUrl="http://translate.google.com/translate?hl="+cel+"&sl=auto&tl="+cel+"&u="+encodeURIComponent(docurl);
     gBrowser.selectedTab = gBrowser.addTab(fordUrl);
     //content.open(fordUrl); //uj ablak/ful megnyitasa - a bongeszo beallitasaitol fugg
  },

  refreshInformation: function(whatToTranslate) {
     if (this.isValidTextLength(whatToTranslate)) {
        if (document.getElementById('statusbar-translator')) {
           var statusBarLabel = document.getElementById('statusbar-translator');
           statusBarLabel.src = "chrome://gtranslatorforff/skin/Ticongreen.png";
        }
        var cel = this.prefs.getCharPref("targetlang");
        var httpRequest = null;

        var baseUrl = "http://translate.google.hu/translate_t";
        var urlParams = "text="+whatToTranslate+"&hl="+cel+"&langpair=auto|"+cel+"&tbb=1";

        function removeHTMLTags(mitkell) { //string megtisztitasa a HTML-tagektol
           var strTagStrippedText = mitkell.replace(/<\/?[^>]+(>|$)/g, "");
           return strTagStrippedText;
        }

        function infoReceived() {  //ha erkezett valasz a Google-tol, akkor a forditas megjelenitese
           var allstring = document.getElementById("translator-strings");
           var output = httpRequest.responseText;
           if (whatToTranslate[0]==" ") { var kezdospace=" "; } else { var kezdospace=""; } //ha a kijelolt szoveg elso karaktere space, akkor a leforditott ele is teszunk
           if (whatToTranslate[whatToTranslate.length-1]==" ") { var vegespace=" "; } else { var vegespace=""; } //ha a kijelolt szoveg utolso karaktere space, akkor a leforditott ele is teszunk
           if (output.length) { //kimeneti string felepitese
              output = output.replace(/&quot;/gi,'"');
              output = output.replace(/&lt;/gi,'<');
              output = output.replace(/&gt;/gi,'>');
              output = output.replace(/&amp;/gi,'&');
              output = output.replace(/&#39;/gi,"'");
              var fieldArray = output.split('</head>');
              if (fieldArray[1].search('class="short_text"')!=-1) {
                 var tempResz = fieldArray[1].split('<span id=result_box class="short_text">');
              }
              else if (fieldArray[1].search('class="medium_text"')!=-1) {
                 var tempResz = fieldArray[1].split('<span id=result_box class="medium_text">');
              }
              else {
                 var tempResz = fieldArray[1].split('<span id=result_box class="long_text">');
              }
              var kimenet = tempResz[1].split('</span></div>');
              var focusedWindow = document.commandDispatcher.focusedWindow; //ez oldotta meg a "frame-ben nem forditok" problemat
              var range = focusedWindow.getSelection().getRangeAt(0);
              range.deleteContents();
              range.insertNode(document.createTextNode(kezdospace+removeHTMLTags(kimenet[0])+vegespace));
              if (document.getElementById('statusbar-translator')) {
                 var statbaricon = document.getElementById('statusbar-translator');
                 statbaricon.src = "chrome://gtranslatorforff/skin/Ticon.png";
              }
              // document.getElementById('statusbar-translator').tooltipText = "Kesz";
           }
        }

        httpRequest = new XMLHttpRequest();
        httpRequest.open("POST", baseUrl, true);
        httpRequest.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
        httpRequest.setRequestHeader("Content-length", urlParams.length);
        httpRequest.setRequestHeader("Connection", "close");
        httpRequest.onload = infoReceived;
        httpRequest.send(urlParams);
     }
     else { //ha a kijelolt szoveg hossza <=0 vagy >38000
        var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                      .getService(Components.interfaces.nsIPromptService);
        prompts.alert(null,"Google Translator",this.strings.getString("errorMessageOnWrongTextLength"));
     }
  },

  openOptions: function() {
     window.openDialog('chrome://gtranslatorforff/content/options.xul','Options','chrome, dialog, modal, centerscreen, resizable');
  }
};

window.addEventListener("load", function(e) { zol_bod_google_translator.onLoad(e); }, false);